<template>
  <div>
    <hero-section
      :title="`${$t('tea')} '${tea.name}'`"
      :subtitle="tea.summary"
    />
    <section class="container">
      <head-breadcrumb
        :items="[
          { text: $t('tea_title'), to: localePath('tea') },
          { text: tea.name, to: localePath({ name: 'tea-slug', params: { slug: tea.slug } }) },
        ]"
      />
      <main class="content">
        <div class="columns ">
          <div class="column is-three-quarters-desktop">
            <article
              v-if="tea.comments"
              class="notification is-info"
            >
              <p class="title">
                {{ $t('comments') }}
              </p>
              <div class="content">
                {{ tea.comments }}
              </div>
            </article>
            <article
              v-if="tea.ingredients"
              class="notification is-warning is-light"
            >
              <p class="title">
                {{ $t('ingredients') }}
              </p>
              <div class="content">
                <div class="tags are-medium">
                  <nuxt-link
                    v-for="{ id, name, has_theine } in tea.ingredients"
                    :key="id"
                    :to="localePath({ name: 'tea', query: { ingredient: id } })"
                    class="tag"
                    :class="{ 'is-warning': has_theine, 'is-info': !has_theine }"
                    :title="has_theine ? 'Contient de la théine' : ''"
                  >
                    {{ name }}
                  </nuxt-link>
                </div>
              </div>
            </article>
            <article class="notification is-link">
              <p class="title">
                {{ $t('purchase_statistics') }}
              </p>
              <div class="content">
                <table>
                  <tbody>
                    <tr>
                      <th>{{ $t('price_per_kilo') }}</th>
                      <td>
                        <table>
                          <thead>
                            <tr>
                              <td>{{ $t('min') }}</td>
                              <td>{{ $t('average') }}</td>
                              <td>{{ $t('max') }}</td>
                            </tr>
                          </thead>
                          <tbody>
                            <tr>
                              <td>{{ purchased.min.price_per_kilogram }} €</td>
                              <td>{{ purchased.avg.price_per_kilogram }} €</td>
                              <td>{{ purchased.max.price_per_kilogram }} €</td>
                            </tr>
                          </tbody>
                        </table>
                      </td>
                    </tr>
                    <tr>
                      <th>{{ $t('number_of_purchases') }}</th>
                      <td>{{ purchased.count }}</td>
                    </tr>
                    <tr>
                      <th>{{ $t('total_quantity_purchased') }}</th>
                      <td>{{ purchased.sum.quantity_in_grams }} grammes</td>
                    </tr>
                  </tbody>
                </table>
              </div>
            </article>
          </div>
          <div class="column">
            <article class="notification is-success">
              <div class="content">
                <div class="card">
                  <div class="card-image">
                    <figure class="image">
                      <img
                        height="200"
                        width="200"
                        :src="getThumbnail(tea.picture, { width: 200, height: 200, fit: 'cover' })"
                        alt="picture of the tea"
                      >
                    </figure>
                  </div>
                  <div class="card-content">
                    <div class="content">
                      <table>
                        <tbody>
                          <tr>
                            <th>{{ $t('infusion_temperature') }}</th>
                            <td>{{ tea.celsius }}°C</td>
                          </tr>
                          <tr>
                            <th>{{ $t('infusion_duration') }}</th>
                            <td v-if="tea.max_time_to_infuse === tea.min_time_to_infuse">
                              {{ tea.min_time_to_infuse }}'
                            </td>
                            <td v-else>
                              {{ tea.min_time_to_infuse }}' - {{ tea.max_time_to_infuse }}'
                            </td>
                          </tr>
                          <tr>
                            <th>{{ $t('we_like') }}</th>
                            <td>
                              <span
                                v-for="bubble in tea.who_like"
                                :key="bubble.id"
                                :class="tagClassesFromBubbleId(bubble.id)"
                              >
                                {{ bubble.name }}
                              </span>
                            </td>
                          </tr>
                          <tr>
                            <th>{{ $t('store') }}</th>
                            <td v-if="tea.link">
                              🔗
                              <nuxt-link
                                target="_blank"
                                :href="tea.link"
                              >
                                {{ tea.shop.name }}
                              </nuxt-link>
                            </td>
                            <td v-else>
                              {{ tea.shop.name }}
                            </td>
                          </tr>
                        </tbody>
                      </table>
                    </div>
                  </div>
                </div>
              </div>
            </article>
            <article class="notification is-link">
              <div class="content">
                <div class="card">
                  <div class="card-content">
                    <div class="content">
                      <div class="columns">
                        <div class="column is-narrow">
                          <qr-code
                            :value="`https://${domain}${route.fullPath}`"
                            render-as="svg"
                            :size="100"
                            level="H"
                          />
                        </div>
                        <div class="column">
                          <div class="title is-6">
                            {{ tea.name }}
                          </div>
                          <div class="subtitle is-6">
                            {{ tea.summary }}
                          </div>
                          <div class="content">
                            <div class="field is-grouped is-grouped-multiline">
                              <div class="control">
                                <div class="tags has-addons">
                                  <span class="tag is-white">🌡</span>
                                  <span class="tag is-danger is-light">{{ tea.celsius }}°C</span>
                                </div>
                              </div>

                              <div class="control">
                                <div class="tags has-addons">
                                  <span class="tag is-white">⏳</span>
                                  <span
                                    v-if="tea.max_time_to_infuse === tea.min_time_to_infuse"
                                    class="tag is-info is-light"
                                  >{{ tea.min_time_to_infuse }}'</span>
                                  <span
                                    v-else
                                    class="tag is-info is-light"
                                  >
                                    {{ tea.min_time_to_infuse }}' - {{ tea.max_time_to_infuse }}'
                                  </span>
                                </div>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </article>
          </div>
        </div>
      </main>
    </section>
  </div>
</template>

<script setup>
import { computed } from 'vue'
import QrCode from 'qrcode.vue'
import { useLocalePath } from '#i18n'

const route = useRoute()

const { host } = useRequestHeaders(['host'])
const domain = computed(() => {
  try {
    return host ?? `${window.location.hostname}:${window.location.port}`
  }
  catch {
    return null
  }
})

const { fetchTea, fetchTeaPurchaseStats, tagClassesFromBubbleId, getThumbnail } = useTea()

const tea = await fetchTea(route.params.slug)
const purchased = await fetchTeaPurchaseStats(route.params.slug)

const localePath = useLocalePath()
</script>

<style lang="scss" scoped>
main {
  margin: 20px 0;
}

nav.head-breadcrumb {
  margin-top: 1.5rem;
}

.content table th {
  vertical-align: middle;
}
</style>
